#define Version "171019"
// modif rinit RA0 en sortie  APRES init UART1 => Cde Relay  via Android OK

//#define Version "171017"
// sortie led ou Relay1 sur RA0  ....  ne marche Pas avec la cde BLE Android ???
// deconnecter ICSP pour RUN
// rajout test retour cde par appli Android
// cot APPINVENTOR 2
// BLE_12F1840_171016.apk
// BLE_12F1840_171016_Designer.jpg
// Pas assez de place pour gerer le OWS DS18B20 sensor
//  Used RAM (bytes): 238 (99%)  Free RAM (bytes): 2 (1%)
//  Used ROM (program words): 3276 (80%)  Free ROM (program words): 820 (20%)

// Rajout UART SOFT sur RA2
//  suivre .. NON, car ce PIC n'a Pas assez de resssources

#define Projet "12F1840_EA2_Uart_RA4_RA5_UART_soft_RA1_BLE_1710.mcppi"
#define Source "_12F1840_EA2_UART1_UART_Soft_BLE"    // sans date ni  extension !

#define Langage "MikroC 7.1.0"
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_BlueTooth_BLE"
#define MCU "12F1840 DIP8"
#define POWER_SUPPLY "3,3V"
#define OSCILLATEUR_INTERNE
#define FOSC 16MHZ
#define EEPROM_FILE "xxx_Eeprom.ihex"

// config Bits :
// P12F1840_FOSC_Interne_16MHz.cfgsch
//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1EFF

 // deconnecter l'ICSP pour reduire la conso.
 /*
 pour utiliser l'I2C, 
 il faut reaffecter L'UART RA0 RA1 par defaut,   et L'ADC sur d'autres PIN  Hardware
  12F1840
  pin 1     VDD Alim +5.0
  pin 2     RA5   UART RX <---    UART
  pin 3     RA4   UART --> TX
  pin 4     RA3/MCLR/VPP -- ICSP Reset   R=5.6K  de rappel au +3,3V
  pin 5     RA2 -----------Soft UART TX (seulement)
  pin 6     RA1  ICSP Clock  ----->    Analog Input
  pin 7     RAO  ICSPDAT  ---- sortie Relay 1
  pin 8    VSS alim 0V

*/



#define TAB 9
#define CLS 12
#define CR 13
#define LF 10
#define STX 2
#define ETX 3
#define OFF 1     // because Relay tir au +VCC
#define ON 0

#include "built_in.h"     // for  Hi  Lo ..etc

#define Byte unsigned char
#define Word unsigned int


sbit Relay1 at LATA.B0  ;
sbit Relay1_Direction at TRISA.B0 ;

#define MAXLEN1 44
volatile unsigned char buffer1[MAXLEN1 ];
volatile unsigned  char * p1;
char TEXTE[46];
char CRam1[22];
char *txt;
//char TR=0;

unsigned short error=0;
volatile unsigned int CptErr=0;
volatile int Index1=0;
volatile  unsigned char c1=0;
volatile unsigned int i1=0;
volatile int Flag_Buffer1;
unsigned int i=0;
unsigned int j=0;
unsigned int k=0;

unsigned int EAx=0;

Word Pas=0;
Word Flag_Timer0=0;
Word Count0=0;


void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF1(void);
void interrupt(void) ;
void RAZ_Buffer1(void);

#define UART3_Write Soft_UART_Write
void UART3_Write_Text(char * t) ;
void UART3_Write_CText(const char * t);
void Wait_250mS(void);
void CRLF3(void) ;
unsigned int Lecture_ADC(unsigned char ch);

void Interrupts() iv 0x0004 ics ICS_AUTO 
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {  
      c1 = RCREG;
      //TXREG=c1;
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       TXREG='@';     // echo of receiveid char
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      TXREG='*';
      CptErr++;
       c1 = RCREG;
      }
      
     if ( ( (i1>0) && (c1==LF)) || ((i1>0) && (c1==CR))   || (i1>=MAXLEN1-1) )
     //if (  (i1>2) )// || (c1==LF))
      {
      buffer1[i1]=0;
      if (c1==CR) c1=RCREG;
      Flag_Buffer1=1;
      Index1=i1;
      i1++;
      RCIE_bit=0 ; //interdit IT Reception UART
      i1=0;
      c1=0;
      }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
    }
   if((TMR0IE_bit)&&(TMR0IF_bit))
  {
        Count0--;
       if (Count0>0)
       {
        TMR0=6;
        }
        else
        {
          Count0=0;
          Flag_Timer0=1;
          TMR0IE_bit=0;
          buffer1[i1]=0;
          Index1=i1;
          i1=0;
          c1=0;
        }
    TMR0IF_bit=0;
   }

 }

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
      Delay_ms(1);

}


void Init_Timer0(unsigned int V1)
{  //Prescaler 1:256; TMR0 Preload = 6;
//  Actual Interrupt Time : 16 ms at 16MHz
  OPTION_REG  = 0x87;
  TMR0        = 6;
  INTCON      = 0xA0;
  TMR0IE_bit=1;
  Count0=V1;
  TMR0IF_bit=0;
  Flag_Timer0=0;

}

void Raz_Buffer1()
{  
      Flag_Buffer1 =0;
      // nettoye le buffer
      for(Index1=0;Index1<MAXLEN1-1;Index1++)  buffer1[Index1]=0;
      c1=RCREG;
      p1=0;
      i1=0;
      Index1=0;
      c1=0;
      RCIE_bit = 1;

}

void Stop_Timer0(void)
{
   Flag_Timer0=0;
   TMR0=6;
   TMR0IF_bit=0;
   TMR0IE_bit=0;
   Count0=0;
   }

void Send_Cde_display_response(const char* Cde)
{  char *p2;
   Raz_Buffer1();
   p2=0;
   UART3_Write_CText(Cde);
   strConstRamCpy(txt,Cde);
   k=strlen(txt);
   *(txt-1)=0;
   UART1_Write_Text(txt);
    Init_Timer0(100) ;
   while((p2==0) && (Flag_Timer0==0) )
   {
   Delay_ms(100);
   p2=strstr(buffer1,"OK");
   }
   Stop_Timer0();
   if(p2>0) Pas++;
   Delay_ms(26);  // duree maxi de reponse Version
 }

void BLE_HM10_Init()
{  
  int N;  
  //char ADDR[32];
  N=0;     
  while(N<11)
  {
  UART1_Write_CText("BlaBla_Car");
  N++;
  }
  CRLF1();
  strConstRamCpy(CRam1,"OK"); 
  Send_Cde_display_response("AT\r\n");
  Send_Cde_display_response("AT+RESET\r\n");
  //UART1_Write_CText(" Cde initiale(AT)\r\n");  // p 61-62

  Send_Cde_display_response("AT+VERSION\r\n");
  Send_Cde_display_response("AT+PIN123456\r\n");
  Send_Cde_display_response("AT+NAMEHM10_7EE1\r\n");
  Send_Cde_display_response("AT+ADDR\r\n");
  Send_Cde_display_response("AT+UUID\r\n");
  Send_Cde_display_response("AT+POWE\r\n");
}



void UART3_Write_Text(char * t)
{
while(*(t)>0)
{
Soft_UART_Write(*(t++));
}
}


void UART3_Write_CText(const char * t)
{
  while(*(t)>0)
  {
     Soft_UART_Write(*(t++));
  }
}
// pour eviter les repetitions de macro delay
 void Wait_250mS()
 {
   Delay_ms(250);
 }


void CRLF3(void)
{
Soft_UART_Write(13); Soft_UART_Write(10);
}

 unsigned int Lecture_ADC(unsigned char ch)
 {
  unsigned int k;
  // to cover channel 0 to 6
  //ADCON0=(ADCON0 & 0xC7)+ (ch<<3) ;
  // to cover only channel 0 & 1

  ADCON0=(ch<<2) +1; // +1 correspond  TMR0 ON
  Delay_ms(15);      // mimimum delay to stabilise ADC input
  ADCON0.GO=1;     // start conversion Set the bit
  _asm nop       // minimum delay recommended by Microchip
  while( ADCON0.GO==1); // TEST the same bit , becomes zero if conversion is finished
   k=ADRESH<<8;
   k=k + ADRESL;
  return (k);
 }



void main() 
{
  // FOSC INTERNE
  // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // 0=4xPLL OFF, 1110=IOFS=8Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // OSCCON=0b01110000; // choix 8Mhz  internal osc
  OSCCON=0b01111000;    // choix 16Mhz  internal osc
  Wait_250mS();
  
  OPTION_REG=0;
  ANSELA=0b00000010;     // RA1=Analog
  // RA5 input RX , RA4 output TX, RA0 = Relay1 output
  // RA2 UART SOFT TX
  TRISA =0b00101010;

  //NOT_WPUEN_bit=0;
  //WPUA=0b00111100;


  CCP1CON=0;     // weak pull up on RX & TX & RA0  R1
  CCP1AS=0b00001000;   // voir page 190
  CM1CON0=0x07;       // disable comparators
  CM1CON1=0x07;
  FVREN_bit=0;
  SRCON0=0;
  SRCON1=0;
  SRLEN_bit=0; // disable Latch
  
  _asm NOP ;
   // RA4=TX RA5=RX   (voir page 111 )
  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  _asm NOP ;
  APFCON.RXDTSEL=1;   // RX sur
  _asm NOP ;
  APFCON.TXCKSEL=1;   // TX sur RA4
  _asm NOP ;



   Wait_250mS();
   //i=j=k=0;
  // TR=1;
  


   // my Own init ADC !
   FVRCON=0;
   FVRCON.B7=1;
   ADFVR1_bit=  0; // Vref=1,024V
   ADFVR0_bit=  1;
   while(FVRRDY_bit==0);

   ADCON0=0;
   // ADCON0.CHS4=0;
   // ADCON0.CHS3=0;
   //ADCON0.CHS2=0;
   //ADCON0.CHS1=0;
   ADCON0.CHS0=1; // AN 1 selected  (RA1)

   ADCON1.ADFM=1;  // right justified
   ADCON1.ADCS2= 1;  // FOSC/64
   ADCON1.ADCS1= 1;
   ADCON1.ADCS0= 0;
   ADCON1.ADPREF1=1;  // use internal +VREF
   ADCON1.ADPREF0=1;
   

   Pas=0;
   
    //char Soft_UART_Init(char *port, char rx_pin, char tx_pin, unsigned long baud_rate, char inverted);
   Soft_UART_Init(&PORTA,5,2,19200,0);
   UART3_Write_CText("Source:"Source"_"Version".c\r\n");
   UART3_Write_CText("\r\n Init SOFTW.UART3 TX(RA2) RX(RA5)\r\n");
   // nota RX pin same as RX UART1 ! mais NON utilis


   UART1_Init(19200);
    CRLF1();
   UART1_Write_CText(" Init Hardw.UART1 RX(RA4) TX(RA5)\r\n");
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo
   if (PIR1.RCIF==1) c1 = RCREG;     // vide fifo

  // IMPERATIF  ..  declarer APRES init UART1
  Relay1_Direction=0;
  Relay1=OFF;
  
   // verif clignotement Led ou relay sur RA0
   /*
  i=0;
  do
  {
   Relay1=ON;
   UART3_Write_CText(" Relay1 ON\r\n");
   Delay_1sec();
    Relay1=OFF;
    UART3_Write_CText(" Relay1 OFF\r\n");
    Delay_1sec();
     i++;
   }
   while(i<5);
   */
     txt=&TEXTE[0];
   Raz_Buffer1();
   GIE_bit=0;
   RCIE_bit=0;

   UART3_Write_CText(" Init module BLE HM10 :\r\n");
   Raz_Buffer1();
   BLE_HM10_Init()   ;
   UART3_Write_CText("Init OK,r\n");


   UART1_Write_CText("AT+START\r\n");   // envoi sur BLE HM10
   UART3_Write_CText("AT+START\r\n");   // envoi sur termianl Display
   Wait_250mS() ;   // laisse passer la reponse
   
   PEIE_bit=1;
   RCIE_bit =1;
   GIE_bit=1;
   TMR0IE_bit=0;
   UART3_Write_CText("40 sec pour se Connecter / Android Apli.\r\n");
   Raz_Buffer1();
    i=39;
  // si  Led verte clignote sur le module BLE HM10
  // ET si connect sur andorid  APK => retour OK+CONN\r\n
   while(i>0)
   {   Raz_Buffer1();
       Delay_1sec() ;
      if (strstr(buffer1,"+CONN")>0) break;
       j=i/4;
      if(i%4==0)
      {
          UART3_Write(j+48);CRLF3();
          }
      i--;
      if(strstr(buffer1,"ERROR=103"))  break; // deja connect
   };
   if (i>0)
    UART3_Write_CText("\r\nConnection BLE OK.\r\n");
    else
    {
      UART3_Write_CText("\r\nPB module BLE NON Connect\r\n");
     Pas=0;
      Delay_1sec() ;
     UART3_Write_CText("\r\nReset\r\n");
     _asm Goto 0;
     }
    Delay_1sec()  ;
   j=0;
   p1=0;
   do
   {
     Raz_Buffer1();
     Delay_1sec() ;
     // exploration contenu buffer1
     if(i1>0)
     {

     p1=strstr(buffer1,"LOST");
     if (p1>0)
     {
       UART3_Write_CText("\r\nPerte de Connection BLE \r\n Reset dans 2sec \r\n");
       Delay_1sec()  ;
       _asm goto 0;    // reset
      }
      p1=strstr(buffer1,"LD1=");   // etat commande led1 ou Relay1 from BLE
      if (p1>0)
      {
        if (*(p1+4)=='1')
        {
          UART1_Write_CText("S1=1\r\n");   // retour d'ordre
          Relay1=ON;
           UART3_Write_CText(" Relay1_ON\r\n");
        }
        if (*(p1+4)=='0')
        {
          UART1_Write_CText("S1=0\r\n");
          Relay1=OFF;
           UART3_Write_CText(" Relay1_OFF\r\n");
        }

      }

      // nota : Pas asse d' E/S pour traiter une sortie led ou relay2 LD2
     /*
      p1=strstr(buffer1,"LD2=");
      if (p1>0)
      {
        if (*(p1+4)=='1')UART1_Write_CText("S2=1\r\n");   // retour d'ordre
        if (*(p1+4)=='0')UART1_Write_CText("S2=0\r\n");   // retour d'ordre
      }
      */
      // Pas assez de ram pour ci-dessous
      /*
       p1=strstr(buffer1,"DISCONNECT=");   // etat commande led1 ou Relay1 from BLE
      if(p1>0)
      {
       UART3_Write_CText(" Deconnection cot Appli Android \r\n");//
        Delay_1sec() ;
        asm goto 0; // Reset
      }
      */
      // pour debugging
       UART3_Write_Text(buffer1);
       CRLF3();
     }


     j++;
     UART3_Write_CText("I am Alive j=");  // indice de progression
     WordToStr(j,CRam1);
     UART3_Write_Text(CRam1);CRLF3();
     // mesure analogiaque 1,024V 1024 pts
     strConstRamCpy(txt ,"j= 1023;E1= 1023");
     strncpy(txt+2,CRam1,5);
     //LM35DZ  10mV/C
     EAx=Lecture_ADC(1);  // mesure en 1/10em de degres
     WordToStr(EAx,CRam1);
     strncpy(txt+12,CRam1,5);
     UART1_Write_Text(txt);
     CRLF1();

   }while(1);

  }
/*


_12F1840_EA2_UART1_UART_Soft_BLE_171017.c

En tete de programme, je teste la sortie RA0 (avec une led au lieu d'un relay)
dans une boucle de 4 clignotement de 2 seconde..
la led clignote bien

mais via ma commande bluetooth, bien que je recoive correctement cette commande
et demande l'activation ou pas de la sortie RA0 .. NIB , RIEN ne se passe ??

un doute aussi sur le fait QUE JE SOIS  98% de RAM
(Used RAM (bytes): 235 (98%)  Free RAM (bytes): 5 (2%))
et qu'il pourrait peut etre  y avoir des effets de bords ..
SOUVENT RENCONTRES AVEC MIKROC lorsqu'on est presque FULL en RAM!

J'ai constat que si l'init UART1  utilisant RA4=TX1 RA5=RX1
est place AVANT le test RA0 clignotement .. CA NE MARCHE PAS ..
si Init UART1 place Apres .. c'est OK

la laison UART1 est bien OK avec le module BLE HM10
La Liaison UART3 software est aussi OK

La solution ou le palliatif  ce probleme:
Reinitialiser la Pin RA0 comme SORTIE, apres l'init de l'UART1 !

   UART1_Init(19200);
    CRLF1();
   UART1_Write_CText(" Init Hardw.UART1 RX(RA4) TX(RA5)\r\n");
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo
   if (PIR1.RCIF==1) c1 = RCREG;     // vide fifo
   Relay1_Direction=0;
   Relay1=OFF;

   // verif clignotement Led ou relay sur RA0 .. OK
Apres cette modif ,ma commande BlueTooth est bien active cot PIC

resultats des echanges visualiss sur le terminal display (UART3 software)

Source:_12F1840_EA2_UART1_UART_Soft_BLE_171017.c

 Init SOFTW.UART3 TX(RA2) RX(RA5)
 Init module BLE HM10 :
AT
AT+RESET
AT+VERSION
AT+PIN123456
AT+NAMEHM10_7EE1
AT+ADDR
AT+UUID
AT+POWE
Init OK,r
         AT+START
40 sec pour se Connecter / Android Apli.
9
8

Connection BLE OK.
I am Alive j=    1
I am Alive j=    2
I am Alive j=    3
I am Alive j=    4
I am Alive j=    5
I am Alive j=    6
I am Alive j=    7
I am Alive j=    8
 Relay1_ON                                <-- pas de changement ???        (avant la modif )
LD1=1
I am Alive j=    9
I am Alive j=   10
I am Alive j=   11
I am Alive j=   12
I am Alive j=   13
 Relay1_OFF
LD1=0
I am Alive j=   14
I am Alive j=   15


===========================

0 1 mikroCPIC1618.exe -MSF -DBG -pP12F1840 -RA -C -O00000114 -fo16 -N"
C:\_MikroC\_MesProjets_MikroC\_BlueTooth_BLE\12F1840_EA2_Uart_RA4_RA5_UART_soft_RA1_BLE_1710.mcppi" -EH"
C:\_MikroC\_MesProjets_MikroC\_BlueTooth_BLE\12F1840_Sleep.ihex" -SP"
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"
C:\_MikroC\_MesProjets_MikroC\_BlueTooth_BLE\" -IP"
C:\_MikroC\_MesProjets_MikroC\_BlueTooth_BLE\" "_12F1840_EA2_UART1_UART_Soft_BLE_171017.c" "
_lib_Math.mcl" "
_lib_MathDouble.mcl" "
_lib_System.mcl" "
_lib_Delays.mcl" "
_lib_CType.mcl" "
_lib_CString.mcl" "
_lib_CStdlib.mcl" "
_lib_Conversions.mcl" "
_lib_OneWire.mcl" "
_lib_SoftUART.mcl" "
_lib_EEPROM.mcl" "
_lib_I2C_a12.mcl" "
_lib_PWM_a2.mcl" "
_lib_UART_a01.mcl"
0 1139 Available RAM: 240 [bytes], Available ROM: 4096 [bytes]
0 122 Compilation Started P12F1840.c
992 123 Compiled Successfully P12F1840.c
0 122 Compilation Started
_lib_Delays.c
123 123 Compiled Successfully
_lib_Delays.c
0 122 Compilation Started _12F1840_EA2_UART1_UART_Soft_BLE_171017.c
0 1004 interrupt handler (Interrupts at 0x0004) _12F1840_EA2_UART1_UART_Soft_BLE_171017.c
406 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _12F1840_EA2_UART1_UART_Soft_BLE_171017.c
540 123 Compiled Successfully _12F1840_EA2_UART1_UART_Soft_BLE_171017.c
306 1164 Variable 'k' has been eliminated by optimizer _12F1840_EA2_UART1_UART_Soft_BLE_171017.c
0 127 All files Compiled in 63 ms
0 1144 Used RAM (bytes): 235 (98%)  Free RAM (bytes): 5 (2%) Used RAM (bytes): 235 (98%)  Free RAM (bytes): 5 (2%)
0 1144 Used ROM (program words): 3229 (79%)  Free ROM (program words): 867 (21%) Used ROM (program words): 3229 (79%)  Free ROM (program words): 867 (21%)
0 125 Project Linked Successfully 12F1840_EA2_Uart_RA4_RA5_UART_soft_RA1_BLE_1710.mcppi
0 128 Linked in 31 ms
0 129 Project '12F1840_EA2_Uart_RA4_RA5_UART_soft_RA1_BLE_1710.mcppi' completed: 250 ms
0 103 Finished successfully: 17 oct. 2017, 12:15:58 12F1840_EA2_Uart_RA4_RA5_UART_soft_RA1_BLE_1710.mcppi


*/